/* dazukofs: access control stackable filesystem

   Copyright (C) 2012 Bitdefender
   Copyright (C) 2008-2010 John Ogness
     Author: John Ogness <dazukocode@ogness.net>

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License
   as published by the Free Software Foundation; either version 2
   of the License, or (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#ifndef __DGET_H__
#define __DGET_H__

#include <linux/dcache.h>

#if 0
static const char * file_base(const char *path)
{
	unsigned int i = 0;
	const char *s = path;

	while (path[i] != '\0') {
		if (path[i] == '/')
			s = &path[i + 1];
		i++;
	}
	return s;
}

static const char * dentry_name(const struct dentry *d)
{
	if (!d || !d->d_name.name)
		return "";
	return d->d_name.name;
}

#define __dget(__dentry) \
	({ struct dentry *d = dget(__dentry); printk(KERN_INFO "%s:%d:g:%p:%s:%d\n", file_base(__FILE__), __LINE__, __dentry, dentry_name(__dentry), atomic_read(&(__dentry)->d_count)); d; })

#define __dput(__dentry) \
	{ printk(KERN_INFO "%s:%d:p:%p:%s:%d\n", file_base(__FILE__), __LINE__, (__dentry), dentry_name(__dentry), atomic_read(&(__dentry)->d_count)); dput(__dentry); }

#else

#define __dget(__dentry) dget(__dentry)
#define __dput(__dentry) dput(__dentry)

#endif

#endif /* __DGET_H__ */
